"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
function firstWordToUppercase(word) {
    return `${word.substring(0, 1).toUpperCase()}${word.substring(1)}`;
}
exports.firstWordToUppercase = firstWordToUppercase;
function strcmp(wordA, wordB) {
    if (wordA.toString() < wordB.toString()) {
        return false;
    }
    return true;
}
exports.strcmp = strcmp;
function checkObject(file, compare, index) {
    const current = file[index].split(":");
    const currentKey = current[0].trim();
    if (!strcmp(currentKey, compare)) {
        return checkObject(file, compare, index + 1);
    }
    return index;
}
function replaceRepositoriesDB(component, file, path) {
    let numberLine = 0;
    let lineToReplaceRepositories = "";
    let lineDB = 0;
    let lineToReplaceDB = "";
    for (const [index, line] of file.entries()) {
        if (line.indexOf("./repositories") > 0) {
            numberLine = index;
            const newLine = line.split("{");
            const newLine2 = newLine[1].split("}");
            let arrayOfRepositories = newLine2[0].split(",");
            arrayOfRepositories = arrayOfRepositories.map(a => a.trim());
            arrayOfRepositories.push(`${firstWordToUppercase(component)}Repository`);
            // eslint-disable-next-line @typescript-eslint/require-array-sort-compare
            arrayOfRepositories.sort();
            const newRepositories = arrayOfRepositories.join(", ");
            lineToReplaceRepositories = `import { ${newRepositories} } from "./repositories";`;
        }
        if (line.indexOf("db: {") > 0) {
            lineDB = checkObject(file, component.toLowerCase(), index + 1);
            if (path === "src/api.ts") {
                lineToReplaceDB = `    ${component.toLowerCase()}: ${firstWordToUppercase(component)}Repository;`;
            }
            else {
                lineToReplaceDB = `        ${component.toLowerCase()}: connection.getCustomRepository(${firstWordToUppercase(component)}Repository),`;
            }
        }
    }
    file.splice(numberLine, 1, lineToReplaceRepositories);
    file.splice(lineDB, 0, lineToReplaceDB);
    fs_1.writeFileSync(path, file.join("\n"));
}
exports.replaceRepositoriesDB = replaceRepositoriesDB;
function checkLineExistsInFile(path, element) {
    const file = fs_1.readFileSync(path)
        .toString()
        .split("\n");
    for (const line of file) {
        if (line.indexOf(element.toLocaleLowerCase()) > 0) {
            return true;
        }
    }
    return false;
}
exports.checkLineExistsInFile = checkLineExistsInFile;
function removeLineExistsInFile(path, element) {
    const file = fs_1.readFileSync(path)
        .toString()
        .split("\n");
    for (const [index, line] of file.entries()) {
        if (line.indexOf(element) > 0) {
            file.splice(index, 1, "");
        }
    }
    file.pop();
    fs_1.writeFileSync(path, file.join("\n"));
}
exports.removeLineExistsInFile = removeLineExistsInFile;
exports.primitivesSdkgen = [
    "bool",
    "int",
    "uint",
    "float",
    "string",
    "date",
    "datetime",
    "bytes",
    "money",
    "cpf",
    "cnpj",
    "email",
    "url",
    "uuid",
    "hex",
    "base64",
    "xml",
    "void",
    "json",
];
exports.primitiveTypescript = ["string", "string[]", "number", "number[]", "boolean", "Date"];
