"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const helpers_1 = require("./helpers");
function generateRepository(component) {
    if (helpers_1.checkLineExistsInFile("src/repositories/index.ts", component)) {
        return;
    }
    const scriptRepository = `import { EntityRepository, Repository } from "typeorm";
import { ${helpers_1.firstWordToUppercase(component)} } from "../models";

@EntityRepository(${helpers_1.firstWordToUppercase(component)})
export class ${helpers_1.firstWordToUppercase(component)}Repository extends Repository<${helpers_1.firstWordToUppercase(component)}> {}
`;
    fs_1.writeFileSync(`src/repositories/${helpers_1.firstWordToUppercase(component)}Repository.ts`, scriptRepository);
    fs_1.appendFileSync("src/repositories/index.ts", `export * from "./${helpers_1.firstWordToUppercase(component)}Repository";\n`);
    // Api
    const fileAPI = fs_1.readFileSync("src/api.ts")
        .toString()
        .split("\n");
    helpers_1.replaceRepositoriesDB(component, fileAPI, "src/api.ts");
    // Server
    const fileServer = fs_1.readFileSync("src/server.ts")
        .toString()
        .split("\n");
    helpers_1.replaceRepositoriesDB(component, fileServer, "src/server.ts");
    // Test
    const fileHelpersTest = fs_1.readFileSync("tests/helpers.ts")
        .toString()
        .split("\n");
    helpers_1.replaceRepositoriesDB(component, fileHelpersTest, "tests/helpers.ts");
}
exports.generateRepository = generateRepository;
